// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_nav_msgs:msg/BaseConstr.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__BASE_CONSTR__STRUCT_HPP_
#define TUW_NAV_MSGS__MSG__DETAIL__BASE_CONSTR__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_nav_msgs__msg__BaseConstr __attribute__((deprecated))
#else
# define DEPRECATED__tuw_nav_msgs__msg__BaseConstr __declspec(deprecated)
#endif

namespace tuw_nav_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct BaseConstr_
{
  using Type = BaseConstr_<ContainerAllocator>;

  explicit BaseConstr_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->v_max = 0.0;
      this->av_max = 0.0;
      this->w_max = 0.0;
      this->aw_max = 0.0;
      this->omg_wh_max = 0.0;
    }
  }

  explicit BaseConstr_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->v_max = 0.0;
      this->av_max = 0.0;
      this->w_max = 0.0;
      this->aw_max = 0.0;
      this->omg_wh_max = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _v_max_type =
    double;
  _v_max_type v_max;
  using _av_max_type =
    double;
  _av_max_type av_max;
  using _w_max_type =
    double;
  _w_max_type w_max;
  using _aw_max_type =
    double;
  _aw_max_type aw_max;
  using _omg_wh_max_type =
    double;
  _omg_wh_max_type omg_wh_max;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__v_max(
    const double & _arg)
  {
    this->v_max = _arg;
    return *this;
  }
  Type & set__av_max(
    const double & _arg)
  {
    this->av_max = _arg;
    return *this;
  }
  Type & set__w_max(
    const double & _arg)
  {
    this->w_max = _arg;
    return *this;
  }
  Type & set__aw_max(
    const double & _arg)
  {
    this->aw_max = _arg;
    return *this;
  }
  Type & set__omg_wh_max(
    const double & _arg)
  {
    this->omg_wh_max = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_nav_msgs__msg__BaseConstr
    std::shared_ptr<tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_nav_msgs__msg__BaseConstr
    std::shared_ptr<tuw_nav_msgs::msg::BaseConstr_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const BaseConstr_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->v_max != other.v_max) {
      return false;
    }
    if (this->av_max != other.av_max) {
      return false;
    }
    if (this->w_max != other.w_max) {
      return false;
    }
    if (this->aw_max != other.aw_max) {
      return false;
    }
    if (this->omg_wh_max != other.omg_wh_max) {
      return false;
    }
    return true;
  }
  bool operator!=(const BaseConstr_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct BaseConstr_

// alias to use template instance with default allocator
using BaseConstr =
  tuw_nav_msgs::msg::BaseConstr_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_nav_msgs

#endif  // TUW_NAV_MSGS__MSG__DETAIL__BASE_CONSTR__STRUCT_HPP_
