// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from tuw_nav_msgs:msg/DiffDriveCmdVWVec.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__DIFF_DRIVE_CMD_VW_VEC__FUNCTIONS_H_
#define TUW_NAV_MSGS__MSG__DETAIL__DIFF_DRIVE_CMD_VW_VEC__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "tuw_nav_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "tuw_nav_msgs/msg/detail/diff_drive_cmd_vw_vec__struct.h"

/// Initialize msg/DiffDriveCmdVWVec message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * tuw_nav_msgs__msg__DiffDriveCmdVWVec
 * )) before or use
 * tuw_nav_msgs__msg__DiffDriveCmdVWVec__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__DiffDriveCmdVWVec__init(tuw_nav_msgs__msg__DiffDriveCmdVWVec * msg);

/// Finalize msg/DiffDriveCmdVWVec message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
void
tuw_nav_msgs__msg__DiffDriveCmdVWVec__fini(tuw_nav_msgs__msg__DiffDriveCmdVWVec * msg);

/// Create msg/DiffDriveCmdVWVec message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * tuw_nav_msgs__msg__DiffDriveCmdVWVec__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
tuw_nav_msgs__msg__DiffDriveCmdVWVec *
tuw_nav_msgs__msg__DiffDriveCmdVWVec__create();

/// Destroy msg/DiffDriveCmdVWVec message.
/**
 * It calls
 * tuw_nav_msgs__msg__DiffDriveCmdVWVec__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
void
tuw_nav_msgs__msg__DiffDriveCmdVWVec__destroy(tuw_nav_msgs__msg__DiffDriveCmdVWVec * msg);

/// Check for msg/DiffDriveCmdVWVec message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__DiffDriveCmdVWVec__are_equal(const tuw_nav_msgs__msg__DiffDriveCmdVWVec * lhs, const tuw_nav_msgs__msg__DiffDriveCmdVWVec * rhs);

/// Copy a msg/DiffDriveCmdVWVec message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__DiffDriveCmdVWVec__copy(
  const tuw_nav_msgs__msg__DiffDriveCmdVWVec * input,
  tuw_nav_msgs__msg__DiffDriveCmdVWVec * output);

/// Initialize array of msg/DiffDriveCmdVWVec messages.
/**
 * It allocates the memory for the number of elements and calls
 * tuw_nav_msgs__msg__DiffDriveCmdVWVec__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence__init(tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence * array, size_t size);

/// Finalize array of msg/DiffDriveCmdVWVec messages.
/**
 * It calls
 * tuw_nav_msgs__msg__DiffDriveCmdVWVec__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
void
tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence__fini(tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence * array);

/// Create array of msg/DiffDriveCmdVWVec messages.
/**
 * It allocates the memory for the array and calls
 * tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence *
tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence__create(size_t size);

/// Destroy array of msg/DiffDriveCmdVWVec messages.
/**
 * It calls
 * tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
void
tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence__destroy(tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence * array);

/// Check for msg/DiffDriveCmdVWVec message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence__are_equal(const tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence * lhs, const tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence * rhs);

/// Copy an array of msg/DiffDriveCmdVWVec messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence__copy(
  const tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence * input,
  tuw_nav_msgs__msg__DiffDriveCmdVWVec__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // TUW_NAV_MSGS__MSG__DETAIL__DIFF_DRIVE_CMD_VW_VEC__FUNCTIONS_H_
