// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_nav_msgs:msg/RouteSegment.idl
// generated code does not contain a copyright notice
#include "tuw_nav_msgs/msg/detail/route_segment__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `start`
// Member `end`
// Member `center`
#include "geometry_msgs/msg/detail/pose__functions.h"

bool
tuw_nav_msgs__msg__RouteSegment__init(tuw_nav_msgs__msg__RouteSegment * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // type
  // orientation
  // motion_type
  // start
  if (!geometry_msgs__msg__Pose__init(&msg->start)) {
    tuw_nav_msgs__msg__RouteSegment__fini(msg);
    return false;
  }
  // end
  if (!geometry_msgs__msg__Pose__init(&msg->end)) {
    tuw_nav_msgs__msg__RouteSegment__fini(msg);
    return false;
  }
  // center
  if (!geometry_msgs__msg__Pose__init(&msg->center)) {
    tuw_nav_msgs__msg__RouteSegment__fini(msg);
    return false;
  }
  // level
  return true;
}

void
tuw_nav_msgs__msg__RouteSegment__fini(tuw_nav_msgs__msg__RouteSegment * msg)
{
  if (!msg) {
    return;
  }
  // id
  // type
  // orientation
  // motion_type
  // start
  geometry_msgs__msg__Pose__fini(&msg->start);
  // end
  geometry_msgs__msg__Pose__fini(&msg->end);
  // center
  geometry_msgs__msg__Pose__fini(&msg->center);
  // level
}

bool
tuw_nav_msgs__msg__RouteSegment__are_equal(const tuw_nav_msgs__msg__RouteSegment * lhs, const tuw_nav_msgs__msg__RouteSegment * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // type
  if (lhs->type != rhs->type) {
    return false;
  }
  // orientation
  if (lhs->orientation != rhs->orientation) {
    return false;
  }
  // motion_type
  if (lhs->motion_type != rhs->motion_type) {
    return false;
  }
  // start
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->start), &(rhs->start)))
  {
    return false;
  }
  // end
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->end), &(rhs->end)))
  {
    return false;
  }
  // center
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->center), &(rhs->center)))
  {
    return false;
  }
  // level
  if (lhs->level != rhs->level) {
    return false;
  }
  return true;
}

bool
tuw_nav_msgs__msg__RouteSegment__copy(
  const tuw_nav_msgs__msg__RouteSegment * input,
  tuw_nav_msgs__msg__RouteSegment * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // type
  output->type = input->type;
  // orientation
  output->orientation = input->orientation;
  // motion_type
  output->motion_type = input->motion_type;
  // start
  if (!geometry_msgs__msg__Pose__copy(
      &(input->start), &(output->start)))
  {
    return false;
  }
  // end
  if (!geometry_msgs__msg__Pose__copy(
      &(input->end), &(output->end)))
  {
    return false;
  }
  // center
  if (!geometry_msgs__msg__Pose__copy(
      &(input->center), &(output->center)))
  {
    return false;
  }
  // level
  output->level = input->level;
  return true;
}

tuw_nav_msgs__msg__RouteSegment *
tuw_nav_msgs__msg__RouteSegment__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_nav_msgs__msg__RouteSegment * msg = (tuw_nav_msgs__msg__RouteSegment *)allocator.allocate(sizeof(tuw_nav_msgs__msg__RouteSegment), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_nav_msgs__msg__RouteSegment));
  bool success = tuw_nav_msgs__msg__RouteSegment__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_nav_msgs__msg__RouteSegment__destroy(tuw_nav_msgs__msg__RouteSegment * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_nav_msgs__msg__RouteSegment__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_nav_msgs__msg__RouteSegment__Sequence__init(tuw_nav_msgs__msg__RouteSegment__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_nav_msgs__msg__RouteSegment * data = NULL;

  if (size) {
    data = (tuw_nav_msgs__msg__RouteSegment *)allocator.zero_allocate(size, sizeof(tuw_nav_msgs__msg__RouteSegment), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_nav_msgs__msg__RouteSegment__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_nav_msgs__msg__RouteSegment__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_nav_msgs__msg__RouteSegment__Sequence__fini(tuw_nav_msgs__msg__RouteSegment__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_nav_msgs__msg__RouteSegment__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_nav_msgs__msg__RouteSegment__Sequence *
tuw_nav_msgs__msg__RouteSegment__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_nav_msgs__msg__RouteSegment__Sequence * array = (tuw_nav_msgs__msg__RouteSegment__Sequence *)allocator.allocate(sizeof(tuw_nav_msgs__msg__RouteSegment__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_nav_msgs__msg__RouteSegment__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_nav_msgs__msg__RouteSegment__Sequence__destroy(tuw_nav_msgs__msg__RouteSegment__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_nav_msgs__msg__RouteSegment__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_nav_msgs__msg__RouteSegment__Sequence__are_equal(const tuw_nav_msgs__msg__RouteSegment__Sequence * lhs, const tuw_nav_msgs__msg__RouteSegment__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_nav_msgs__msg__RouteSegment__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_nav_msgs__msg__RouteSegment__Sequence__copy(
  const tuw_nav_msgs__msg__RouteSegment__Sequence * input,
  tuw_nav_msgs__msg__RouteSegment__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_nav_msgs__msg__RouteSegment);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_nav_msgs__msg__RouteSegment * data =
      (tuw_nav_msgs__msg__RouteSegment *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_nav_msgs__msg__RouteSegment__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_nav_msgs__msg__RouteSegment__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_nav_msgs__msg__RouteSegment__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
