// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_nav_msgs:msg/Spline.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__SPLINE__STRUCT_HPP_
#define TUW_NAV_MSGS__MSG__DETAIL__SPLINE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'ctrls'
#include "tuw_nav_msgs/msg/detail/float64_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_nav_msgs__msg__Spline __attribute__((deprecated))
#else
# define DEPRECATED__tuw_nav_msgs__msg__Spline __declspec(deprecated)
#endif

namespace tuw_nav_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Spline_
{
  using Type = Spline_<ContainerAllocator>;

  explicit Spline_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit Spline_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _knots_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _knots_type knots;
  using _ctrls_type =
    std::vector<tuw_nav_msgs::msg::Float64Array_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_nav_msgs::msg::Float64Array_<ContainerAllocator>>>;
  _ctrls_type ctrls;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__knots(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->knots = _arg;
    return *this;
  }
  Type & set__ctrls(
    const std::vector<tuw_nav_msgs::msg::Float64Array_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_nav_msgs::msg::Float64Array_<ContainerAllocator>>> & _arg)
  {
    this->ctrls = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_nav_msgs::msg::Spline_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_nav_msgs::msg::Spline_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_nav_msgs::msg::Spline_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_nav_msgs::msg::Spline_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_nav_msgs::msg::Spline_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_nav_msgs::msg::Spline_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_nav_msgs::msg::Spline_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_nav_msgs::msg::Spline_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_nav_msgs::msg::Spline_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_nav_msgs::msg::Spline_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_nav_msgs__msg__Spline
    std::shared_ptr<tuw_nav_msgs::msg::Spline_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_nav_msgs__msg__Spline
    std::shared_ptr<tuw_nav_msgs::msg::Spline_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Spline_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->knots != other.knots) {
      return false;
    }
    if (this->ctrls != other.ctrls) {
      return false;
    }
    return true;
  }
  bool operator!=(const Spline_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Spline_

// alias to use template instance with default allocator
using Spline =
  tuw_nav_msgs::msg::Spline_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_nav_msgs

#endif  // TUW_NAV_MSGS__MSG__DETAIL__SPLINE__STRUCT_HPP_
