// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from tuw_nav_msgs:msg/IwsCmdVRAT.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__IWS_CMD_VRAT__FUNCTIONS_H_
#define TUW_NAV_MSGS__MSG__DETAIL__IWS_CMD_VRAT__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "tuw_nav_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "tuw_nav_msgs/msg/detail/iws_cmd_vrat__struct.h"

/// Initialize msg/IwsCmdVRAT message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * tuw_nav_msgs__msg__IwsCmdVRAT
 * )) before or use
 * tuw_nav_msgs__msg__IwsCmdVRAT__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__IwsCmdVRAT__init(tuw_nav_msgs__msg__IwsCmdVRAT * msg);

/// Finalize msg/IwsCmdVRAT message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
void
tuw_nav_msgs__msg__IwsCmdVRAT__fini(tuw_nav_msgs__msg__IwsCmdVRAT * msg);

/// Create msg/IwsCmdVRAT message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * tuw_nav_msgs__msg__IwsCmdVRAT__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
tuw_nav_msgs__msg__IwsCmdVRAT *
tuw_nav_msgs__msg__IwsCmdVRAT__create();

/// Destroy msg/IwsCmdVRAT message.
/**
 * It calls
 * tuw_nav_msgs__msg__IwsCmdVRAT__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
void
tuw_nav_msgs__msg__IwsCmdVRAT__destroy(tuw_nav_msgs__msg__IwsCmdVRAT * msg);

/// Check for msg/IwsCmdVRAT message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__IwsCmdVRAT__are_equal(const tuw_nav_msgs__msg__IwsCmdVRAT * lhs, const tuw_nav_msgs__msg__IwsCmdVRAT * rhs);

/// Copy a msg/IwsCmdVRAT message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__IwsCmdVRAT__copy(
  const tuw_nav_msgs__msg__IwsCmdVRAT * input,
  tuw_nav_msgs__msg__IwsCmdVRAT * output);

/// Initialize array of msg/IwsCmdVRAT messages.
/**
 * It allocates the memory for the number of elements and calls
 * tuw_nav_msgs__msg__IwsCmdVRAT__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__IwsCmdVRAT__Sequence__init(tuw_nav_msgs__msg__IwsCmdVRAT__Sequence * array, size_t size);

/// Finalize array of msg/IwsCmdVRAT messages.
/**
 * It calls
 * tuw_nav_msgs__msg__IwsCmdVRAT__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
void
tuw_nav_msgs__msg__IwsCmdVRAT__Sequence__fini(tuw_nav_msgs__msg__IwsCmdVRAT__Sequence * array);

/// Create array of msg/IwsCmdVRAT messages.
/**
 * It allocates the memory for the array and calls
 * tuw_nav_msgs__msg__IwsCmdVRAT__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
tuw_nav_msgs__msg__IwsCmdVRAT__Sequence *
tuw_nav_msgs__msg__IwsCmdVRAT__Sequence__create(size_t size);

/// Destroy array of msg/IwsCmdVRAT messages.
/**
 * It calls
 * tuw_nav_msgs__msg__IwsCmdVRAT__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
void
tuw_nav_msgs__msg__IwsCmdVRAT__Sequence__destroy(tuw_nav_msgs__msg__IwsCmdVRAT__Sequence * array);

/// Check for msg/IwsCmdVRAT message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__IwsCmdVRAT__Sequence__are_equal(const tuw_nav_msgs__msg__IwsCmdVRAT__Sequence * lhs, const tuw_nav_msgs__msg__IwsCmdVRAT__Sequence * rhs);

/// Copy an array of msg/IwsCmdVRAT messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_nav_msgs
bool
tuw_nav_msgs__msg__IwsCmdVRAT__Sequence__copy(
  const tuw_nav_msgs__msg__IwsCmdVRAT__Sequence * input,
  tuw_nav_msgs__msg__IwsCmdVRAT__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // TUW_NAV_MSGS__MSG__DETAIL__IWS_CMD_VRAT__FUNCTIONS_H_
