// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_nav_msgs:msg/IwsCmdVRATVec.idl
// generated code does not contain a copyright notice
#include "tuw_nav_msgs/msg/detail/iws_cmd_vrat_vec__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `v`
// Member `rho`
// Member `phi`
// Member `delta_t`
// Member `state0`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
tuw_nav_msgs__msg__IwsCmdVRATVec__init(tuw_nav_msgs__msg__IwsCmdVRATVec * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    tuw_nav_msgs__msg__IwsCmdVRATVec__fini(msg);
    return false;
  }
  // v
  if (!rosidl_runtime_c__double__Sequence__init(&msg->v, 0)) {
    tuw_nav_msgs__msg__IwsCmdVRATVec__fini(msg);
    return false;
  }
  // rho
  if (!rosidl_runtime_c__double__Sequence__init(&msg->rho, 0)) {
    tuw_nav_msgs__msg__IwsCmdVRATVec__fini(msg);
    return false;
  }
  // phi
  if (!rosidl_runtime_c__double__Sequence__init(&msg->phi, 0)) {
    tuw_nav_msgs__msg__IwsCmdVRATVec__fini(msg);
    return false;
  }
  // delta_t
  if (!rosidl_runtime_c__double__Sequence__init(&msg->delta_t, 0)) {
    tuw_nav_msgs__msg__IwsCmdVRATVec__fini(msg);
    return false;
  }
  // state0
  if (!rosidl_runtime_c__double__Sequence__init(&msg->state0, 0)) {
    tuw_nav_msgs__msg__IwsCmdVRATVec__fini(msg);
    return false;
  }
  return true;
}

void
tuw_nav_msgs__msg__IwsCmdVRATVec__fini(tuw_nav_msgs__msg__IwsCmdVRATVec * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // v
  rosidl_runtime_c__double__Sequence__fini(&msg->v);
  // rho
  rosidl_runtime_c__double__Sequence__fini(&msg->rho);
  // phi
  rosidl_runtime_c__double__Sequence__fini(&msg->phi);
  // delta_t
  rosidl_runtime_c__double__Sequence__fini(&msg->delta_t);
  // state0
  rosidl_runtime_c__double__Sequence__fini(&msg->state0);
}

bool
tuw_nav_msgs__msg__IwsCmdVRATVec__are_equal(const tuw_nav_msgs__msg__IwsCmdVRATVec * lhs, const tuw_nav_msgs__msg__IwsCmdVRATVec * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // v
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->v), &(rhs->v)))
  {
    return false;
  }
  // rho
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->rho), &(rhs->rho)))
  {
    return false;
  }
  // phi
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->phi), &(rhs->phi)))
  {
    return false;
  }
  // delta_t
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->delta_t), &(rhs->delta_t)))
  {
    return false;
  }
  // state0
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->state0), &(rhs->state0)))
  {
    return false;
  }
  return true;
}

bool
tuw_nav_msgs__msg__IwsCmdVRATVec__copy(
  const tuw_nav_msgs__msg__IwsCmdVRATVec * input,
  tuw_nav_msgs__msg__IwsCmdVRATVec * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // v
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->v), &(output->v)))
  {
    return false;
  }
  // rho
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->rho), &(output->rho)))
  {
    return false;
  }
  // phi
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->phi), &(output->phi)))
  {
    return false;
  }
  // delta_t
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->delta_t), &(output->delta_t)))
  {
    return false;
  }
  // state0
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->state0), &(output->state0)))
  {
    return false;
  }
  return true;
}

tuw_nav_msgs__msg__IwsCmdVRATVec *
tuw_nav_msgs__msg__IwsCmdVRATVec__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_nav_msgs__msg__IwsCmdVRATVec * msg = (tuw_nav_msgs__msg__IwsCmdVRATVec *)allocator.allocate(sizeof(tuw_nav_msgs__msg__IwsCmdVRATVec), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_nav_msgs__msg__IwsCmdVRATVec));
  bool success = tuw_nav_msgs__msg__IwsCmdVRATVec__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_nav_msgs__msg__IwsCmdVRATVec__destroy(tuw_nav_msgs__msg__IwsCmdVRATVec * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_nav_msgs__msg__IwsCmdVRATVec__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence__init(tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_nav_msgs__msg__IwsCmdVRATVec * data = NULL;

  if (size) {
    data = (tuw_nav_msgs__msg__IwsCmdVRATVec *)allocator.zero_allocate(size, sizeof(tuw_nav_msgs__msg__IwsCmdVRATVec), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_nav_msgs__msg__IwsCmdVRATVec__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_nav_msgs__msg__IwsCmdVRATVec__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence__fini(tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_nav_msgs__msg__IwsCmdVRATVec__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence *
tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence * array = (tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence *)allocator.allocate(sizeof(tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence__destroy(tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence__are_equal(const tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence * lhs, const tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_nav_msgs__msg__IwsCmdVRATVec__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence__copy(
  const tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence * input,
  tuw_nav_msgs__msg__IwsCmdVRATVec__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_nav_msgs__msg__IwsCmdVRATVec);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_nav_msgs__msg__IwsCmdVRATVec * data =
      (tuw_nav_msgs__msg__IwsCmdVRATVec *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_nav_msgs__msg__IwsCmdVRATVec__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_nav_msgs__msg__IwsCmdVRATVec__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_nav_msgs__msg__IwsCmdVRATVec__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
