// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_nav_msgs:msg/JointsIWS.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__JOINTS_IWS__STRUCT_HPP_
#define TUW_NAV_MSGS__MSG__DETAIL__JOINTS_IWS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_nav_msgs__msg__JointsIWS __attribute__((deprecated))
#else
# define DEPRECATED__tuw_nav_msgs__msg__JointsIWS __declspec(deprecated)
#endif

namespace tuw_nav_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct JointsIWS_
{
  using Type = JointsIWS_<ContainerAllocator>;

  explicit JointsIWS_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->type_steering = "";
      this->type_revolute = "";
    }
  }

  explicit JointsIWS_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    type_steering(_alloc),
    type_revolute(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->type_steering = "";
      this->type_revolute = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _type_steering_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _type_steering_type type_steering;
  using _type_revolute_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _type_revolute_type type_revolute;
  using _steering_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _steering_type steering;
  using _revolute_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _revolute_type revolute;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__type_steering(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->type_steering = _arg;
    return *this;
  }
  Type & set__type_revolute(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->type_revolute = _arg;
    return *this;
  }
  Type & set__steering(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->steering = _arg;
    return *this;
  }
  Type & set__revolute(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->revolute = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_nav_msgs__msg__JointsIWS
    std::shared_ptr<tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_nav_msgs__msg__JointsIWS
    std::shared_ptr<tuw_nav_msgs::msg::JointsIWS_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const JointsIWS_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->type_steering != other.type_steering) {
      return false;
    }
    if (this->type_revolute != other.type_revolute) {
      return false;
    }
    if (this->steering != other.steering) {
      return false;
    }
    if (this->revolute != other.revolute) {
      return false;
    }
    return true;
  }
  bool operator!=(const JointsIWS_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct JointsIWS_

// alias to use template instance with default allocator
using JointsIWS =
  tuw_nav_msgs::msg::JointsIWS_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_nav_msgs

#endif  // TUW_NAV_MSGS__MSG__DETAIL__JOINTS_IWS__STRUCT_HPP_
